<script>
export default {
    /******************************
     * The fiche objet takes as props :
     *  - featureProperties : the object containing the "properties" key of a feature
     *  - thesaurusobject : the thesaurus of the objecttype
     *  - sysmaOrgLabel : the label of the organisation
     ******************************/
    props: {
        'featureProperties': Object,
        'thesaurusObject': Object,
        'sysmaOrgLabel': String
    },
    emits: ['toggleToTabMode', 'corrigerFicheObjet'],
    methods: {
        // replaceApostrophe(str) {
        //     if(typeof str === 'string') {
        //         return str.replaceAll("&#039;", "'");
        //     }
        // },
        decodeHTMLEntities(text) {
            return (text+"").replace(/&#\d+;/gm,function(s) {
                return String.fromCharCode(s.match(/\d+/gm)[0]);
            });
        },

        /******************************
         * Returns false if the parameter is empty and true otherwise
         * @param {String, Array, Number, null, undefined} val 
         ******************************/
        isRenseigne(val) {
            if ((typeof val === 'string' || Array.isArray(val)) && val.length === 0) {
                return false;
            } else if (val === null || val === undefined) {
                return false;
            } else {
                return true;
            }
        },

        /******************************
         * Returns a string that gives a value understandable for the user
         * @param {String, Array, Number} parameterValue 
         * @param {String} parameterType 
         ******************************/
        formatParameterValue(parameterValue, parameterType) {
            console.log("formatParameterValue", parameterValue, parameterType)
            if (parameterType == 'booleanType') {
                if (parameterValue === '0') {
                    return 'Non';
                } else {
                    return 'Oui';
                }
            } else {
                return parameterValue.toString();
            }
        }
    }
}
</script>

<template>

<!-- TITLE OF THE FICHE OBJET -->
    <h3>
        <acronym> {{ decodeHTMLEntities(thesaurusObject.sysma_object_type) + " " }} </acronym>
        <small>
            <a class="text-muted" target="_blank" alt="voir la fiche dictionnaire" title="voir la fiche dictionnaire">
                <span class="glyphicon glyphicon-book"></span>
            </a>
        </small>
    </h3>

    <h1>
    {{ decodeHTMLEntities(featureProperties.name) }}
    <small> {{ sysmaOrgLabel }} </small>
    <small>
        <small> [{{featureProperties.id.substring(1)}}] </small>
    </small>
    </h1>
<!-- --- --- --- --- --- -->


<!-- BUTTON CORRIGER FICHE OBJET -->
    <p>
        <button class="btn btn-default btn-xs" id="editObjectSheetBtn" title="Correction de l'objet"
        @click="$emit('corrigerFicheObjet')">
            <span class="glyphicon glyphicon-pencil text-muted"></span>
            Corriger la fiche objet
        </button>
    </p>
<!-- --- --- --- --- --- -->


<!-- TAB MODE BUTTON -->
    <h2 class="labelSysma labelSysma-donnees">Données
	<span style="float:right;">
        <!-- <button class="btn btn-default btn-xs" onclick="sendData('id=102662&amp;mode=field', 'https:\/\/51.15.226.232/objet/tab-form', 'blocDonnees', event)">
            <span class="glyphicon glyphicon-edit"></span>
            Tab Mode terrain</button> -->
        <button class="btn btn-default btn-xs" id="tabModeBtn" onclick=""
            @click="$emit('toggleToTabMode')">
            <span class="glyphicon glyphicon-edit"></span>
            Tab Mode
        </button>
	</span>
    </h2>
<!-- --- --- --- --- --- -->


<!-- LOOP OVER THE PARAMETERS OF THE OBJECT TO DISPLAY THEIR VALUES -->
    <div id="blocDonnees">
        <template v-for="paramIndex in thesaurusObject.paramArray.length" :key="thesaurusObject.paramArray[paramIndex-1].parameter_id">
            <div class="row rowSysma">
                <div class="col-md-2 col-sm-3 col-xs-12 colonne1">
					<acronym :title="thesaurusObject.paramArray[paramIndex-1].parameter_id">{{decodeHTMLEntities(thesaurusObject.paramArray[paramIndex-1].parameter)}}</acronym>
				</div>
                <div id="renseigneForm" class="col-md-10 col-sm-9 col-xs-12">
                    <div class="row">
                        <div class="colonne2 col-md-9 col-sm-8 col-xs-12">
                            <template v-if="featureProperties.parameters">
                                <div v-if="isRenseigne(featureProperties.parameters[paramIndex-1].value)" class="value sousColonne2-1">
                                    <acronym :title="featureProperties.parameters[paramIndex-1].id">{{formatParameterValue(featureProperties.parameters[paramIndex-1].value, featureProperties.parameters[paramIndex-1].dataType)}}</acronym>
                                </div>
                                <div v-else class="value sousColonne2-1 aucuneValeur">Aucune valeur actuelle</div>
                            </template>
                            <template v-else>
                                <div class="value sousColonne2-1 aucuneValeur">Aucune valeur actuelle</div>
                            </template>
                        </div>
                    </div>
                </div>
            </div>
        </template>
    </div>
<!-- --- --- --- --- --- -->

</template>

<style>

.labelSysma {
    padding:3px;
    padding-left:8px;
    padding-bottom:5px;
    display: block;
    text-align: left;
    background-color: #ececec;
    border-bottom: solid 1px rgba(200,200,200,.2) ;
    background-size: 100px 100px;
    color:#333;
    border-radius: 5px 5px 0 0;
}

</style>